require "numru/ggraph"
include NumRu


molnum    = 1
molnum    = 2
klev      = 0
#klev      = 1
#klev      = 2
#klev      = 3
ncfn_ksp  = "out/abscoef.dwn1e0.nc"
ncfn_ksp  = "out.2e5Pa.dwn1e0/abscoef.nc"
vname_ksp = "AbsCoef"
#ncfn_rad  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps1atm_T250K_ac.nc"
#ncfn_rad  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum_ignore-iso-10/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps1atm_T250K_ac.nc"
#ncfn_rad  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum_ignore-iso-minor/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps1atm_T250K_ac.nc"
#ncfn_rad  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum-testing/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps1atm_T250K_ac.nc"
ncfn_rad  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps2e5Pa_T250K_ac_000000.nc"
vname_rad = "AbsCoef"
#ncfn_cnt  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps1atm_T250K_Cont_ac.nc"
ncfn_cnt  = "../../radmodels/radmodels-2018-08-05_test_comp_kspectrum/lbl_k-dist/prog02.0_calc_ac/out/Test_Ps2e5Pa_T250K_Cont_ac_000000.nc"
vname_cnt = "AbsCoef"

wn1 =   10
wn2 = 2000
#wn1 =   10
#wn2 = 2500
#wn1 = 2440
#wn2 = 2460
#wn1 =    10
#wn2 = 50000
#wn1 =  1303
#wn2 =  1304
#wn1 =  4900
#wn2 =  4930
#wn1 =  4905
#wn2 =  4906
#wn1 = 10000
#wn2 = 20000
#wn1 = 10000
#wn2 = 11000
#wn1 =  4613
#wn2 =  4615
#wn1 =  4770
#wn2 =  4771
#wn1 =  4770.28
#wn2 =  4770.30
#wn1 =  4000.00
#wn2 =  6000.00
#wn1 =  4800.00
#wn2 =  5000.00
#wn1 =  4893.00
#wn2 =  4894.00
#wn1 =  4893.00
#wn2 =  4894.00


###################################
ncfn  = ncfn_cnt
vname = vname_cnt
gp = GPhys::IO.open( ncfn, vname )
#
z = gp.axis('WaveNum').pos.convert_units( Units['cm-1'] )
gp.axis('WaveNum').set_pos(z)
#
press = gp.coord('Press').val
gp = gp.cut('MolNum'=>molnum).cut('Press'=>press[klev])
#
gp_cnt = gp
###################################
ncfn  = ncfn_ksp
vname = vname_ksp
gp = GPhys::IO.open( ncfn, vname )
#
z = gp.axis('WaveNum').pos.convert_units( Units['cm-1'] )
gp.axis('WaveNum').set_pos(z)
#
wn = gp.coord('WaveNum').val
gp = gp.cut('WaveNum'=>wn[1]..wn[-1])
#
gp = gp.cut('LevNum'=>klev+1).cut('MolNum'=>molnum)
#
gp_ksp = gp
###################################
ncfn  = ncfn_rad
vname = vname_rad
gp = GPhys::IO.open( ncfn, vname )
#
z = gp.axis('WaveNum').pos.convert_units( Units['cm-1'] )
gp.axis('WaveNum').set_pos(z)
#
press = gp.coord('Press').val
gp = gp.cut('MolNum'=>molnum).cut('Press'=>press[klev])
#
gp_rad = gp
###################################

gp_ksp = gp_ksp.cut('WaveNum'=>wn1..wn2)
gp_cnt = gp_cnt.cut('WaveNum'=>wn1..wn2)
gp_rad = gp_rad.cut('WaveNum'=>wn1..wn2)

od_threshold = 0.0
#od_threshold = 0.1

# od = ac (m2 mole-1) * N (mol m-2)
#    = ac (m2 mole-1) * Ps / g (kg m-2) / (44*AMU (kg) )
# ac (m2 mole-1) = od / ( Ps / g (kg m-2) / (44*AMU (kg) ) )
ac_threshold = od_threshold / ( press[klev] / 3.6 / (44 * 1.66e-27) )
#ac_threshold = od_threshold / ( press[klev] / 3.6 / (44 * 1.66e-27) * 1e-6)
print "AC threshold: ", ac_threshold, "\n"



va_wn = gp_rad.coord('WaveNum')
gp_ksp_int = gp_ksp.interpolate(va_wn)

gp_ksp_int = gp_ksp_int + gp_cnt
gp_rad     = gp_rad     + gp_cnt


gp_diff    = gp_rad - gp_ksp_int

gp_ksp     = gp_ksp     * 1e4 + 1e-40
gp_ksp_int = gp_ksp_int * 1e4 + 1e-40
gp_rad     = gp_rad     * 1e4 + 1e-40
gp_diff    = gp_diff    * 1e4 + 1e-40

#gp_diff    = gp_diff.abs

itr1 = 4
itr2 = 3
itr1 = 2
itr2 = 1

iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[0,2500,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[2500,5000,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[5000,10000,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[10000,50000,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[675,700,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 4, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[10,50000,10**(-27.5),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[10,2500,10**(-30),1e-15]
#GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[2300,2500,10**(-30),1e-15]
GGraph.set_fig 'itr'=>itr1, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[wn1,wn2,10**(-30),1e-15]

#GGraph.tone gphys, true     #, 'lev'=>levels, 'pat'=>patterns
#GGraph.contour gphys, false #, 'lev'=>levels
#GGraph.color_bar

#GGraph.line gp_ksp    , true , 'annotate'=>false, 'index'=>10, 'legend'=>'kspectrum', 'legend_vx'=>0.2
#GGraph.line gp_ksp_int, false, 'index'=>20, 'legend'=>'kspectrum (int)', 'legend_vx'=>0.2
GGraph.line gp_ksp_int, true, 'annotate'=>false, 'index'=>20, 'legend'=>'kspectrum & CIA', 'legend_vx'=>0.2
GGraph.line gp_rad    , false, 'index'=>30, 'legend'=>'radmodel & CIA', 'legend_vx'=>0.2
GGraph.line gp_diff.abs   , false, 'index'=>40, 'legend'=>'difference', 'legend_vx'=>0.2

gp_diff    = gp_diff / gp_rad
gp_diff[( gp_rad.val.le ac_threshold ).where] = 0.0
GGraph.set_fig 'itr'=> itr2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[wn1,wn2,-2e-1,2e-1]
#GGraph.set_fig 'itr'=> itr2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[wn1,wn2,-1e-1,1e-1]
#GGraph.set_fig 'itr'=> itr2, 'viewport'=>[0.1,0.95,0.15,0.6], 'window'=>[wn1,wn2,-1e-2,1e-2]
GGraph.line gp_diff   , true, 'annotate'=>false, 'index'=>40, 'legend'=>'relative difference', 'legend_vx'=>0.2


#gp_diff = gp_diff.cut('WaveNum'=>10..2500)

gp_diff[( gp_diff.val.abs.lt 1e-2 ).where] = 0.0
gp_diff[( gp_diff.val.abs.ge 1e-2 ).where] = 1.0

p gp_diff.val.sum
p gp_diff.val.size
p gp_diff.val.sum / gp_diff.val.size


DCL.grcls
